/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-08-01
 * 
 */
#include "extern.h"

/* --------------------------
   | Check for a scrap file |
   -------------------------- */
void check_scrap(void)
{
char scrap[256];
long fh;

if (scrp_read(scrap))
	{
	strcat(scrap, "SCRAP.TXT");

	fh = Fopen(scrap, FO_READ);
	if (fh > 0)
		{
		menu_ienable(menu_adr, M_PASTE, TRUE);
		Fclose((int)fh);
		}
	else
		menu_ienable(menu_adr, M_PASTE, FALSE);
	}
}

/* ----------------------------
   | Paste scrap file content |
   ---------------------------- */
void paste_scrap(void)
{
char scrap[256];
long fh;
char c, oc;

if (scrp_read(scrap))
	{
	strcat(scrap, "SCRAP.TXT");

	fh = Fopen(scrap, FO_READ);
	if (fh > 0)
		{
		oc = 0;
		while(Fread((int)fh, 1, &c))
			{
			if (c == '\r' || c == '\n')
				{
				if (c != oc && (oc == '\r' || oc == '\n'))
					{
					oc = 0;
					continue;
					}
		  	if (local_echo) character_out((unsigned char)'\r');
		 	  tcpip_write((unsigned char)'\r');
				}
			else
				{
		  	if (local_echo) character_out((unsigned char)c);
		 	  tcpip_write((unsigned char)c);
				}
			oc = c;
			}
		
		Fclose((int)fh);
		}
	}
}

