/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-08-01
 * 
 */
 
#include "extern.h"

/* ---------------------------
   | Create a new connection |
   --------------------------- */
void new_connection(void)
{
init_tcpip();
}

/* ----------------------
   | Close a connection |
   ---------------------- */
void close_connection(void)
{
close_tcpip();
}

/* ----------------------
   | Dropdown selection |
   ---------------------- */
void drop_connect(OBJECT *ctree, int ctobj)
{
int x, y, i, page, obj;
OBJECT *server_pop;
static int ftext[] = {SRV_1, SRV_2, SRV_3, SRV_4, SRV_5, SRV_6};
char snames[6][41];
int fx, fy, fw, fh;
int last_obj = 0;

wind_update(BEG_UPDATE);

objc_offset(ctree, ctobj, &x, &y);
rsrc_gaddr(R_TREE, SERVPOP, &server_pop);

form_center(server_pop, &fx, &fy, &fw, &fh);
server_pop[0].ob_x = x; server_pop[0].ob_y = y;

for (i = 0; i < 6; i++)
	{
	server_pop[ftext[i]].ob_spec.tedinfo->te_ptext = snames[i];
	server_pop[ftext[i]].ob_width = server_pop[SRV_SBK].ob_x - 1;
	snames[i][0] = 0;
	}

page = 0;
do
	{
	graf_mkstate(&mouse_x, &mouse_y, &m_button, &k_state);
	}while(m_button & 1);

do
	{
	for (i = 0; i < 6 && i < server_cnt; i++)	
		strcpy(snames[i], server_list[page + i]);

	if (server_cnt <= 6)
		{
		server_pop[SRV_DRG].ob_height = server_pop[SRV_SLD].ob_height;
		server_pop[SRV_DRG].ob_y = 0;
		}
	else
		{
		server_pop[SRV_DRG].ob_height = (int)(server_pop[SRV_SLD].ob_height * 6L / server_cnt);
		server_pop[SRV_DRG].ob_y = (int)
			((server_pop[SRV_SLD].ob_height - server_pop[SRV_DRG].ob_height) * (long)page / (server_cnt - 6));
		}

	set_special_objects(server_pop);
	objc_draw(server_pop, ROOT, MAX_DEPTH, x - 1, y - 1, fw + 2, fh + 2);
	release_special_objects(server_pop);

	do
		{	
		graf_mkstate(&mouse_x, &mouse_y, &m_button, &k_state);

		obj = objc_find(server_pop, ROOT, MAX_DEPTH, mouse_x, mouse_y);
		if (last_obj && last_obj != obj)
			{
			objc_change(server_pop, last_obj, 0, x, y, fw, fh,
									server_pop[last_obj].ob_state & ~SELECTED,
									FALSE);

			set_special_objects(server_pop);
			objc_draw(server_pop, last_obj, 1, x - 1, y - 1, fw + 2, fh + 2);
			release_special_objects(server_pop);
			last_obj = 0;
			}
		
		if (obj > -1 && last_obj != obj &&
				(server_pop[obj].ob_flags & SELECTABLE) && 
				!(server_pop[obj].ob_state & DISABLED) &&
				server_pop[obj].ob_spec.tedinfo->te_ptext[0])
			{
			objc_change(server_pop, obj, 0, x, y, fw, fh,
									server_pop[obj].ob_state | SELECTED,
									FALSE);
									
			set_special_objects(server_pop);
			objc_draw(server_pop, obj, 1, x - 1, y - 1, fw + 2, fh + 2);
			release_special_objects(server_pop);
			last_obj = obj;
			}
		}while(!m_button);
	
	switch(obj)
		{
		case SRV_UP:
			if (page > 0)
				{
				page--;
				delay(20);
				}
			break;
			
		case SRV_DWN:
			if (page < server_cnt - 6)
				{
				page++;
				delay(20);
				}
			break;
		
		case SRV_SLD:
			{
			int ox, oy;
			
			objc_offset(server_pop, SRV_DRG, &ox, &oy);
			if (mouse_y < oy)
				{
				page -= 6;
				if (page < 0) page = 0;
				}
			else
				{
				page += 6;
				if (page > server_cnt - 6)
					page = server_cnt - 6;
				}
			break;
			}
			
		case SRV_DRG:
			{
			int pos = graf_slidebox(server_pop, SRV_SLD, SRV_DRG, 1);
			page = (int)(pos * (long)(server_cnt - 6) / 1000);
			break;
			}
		}
		
	}while(obj == SRV_UP || obj == SRV_DWN ||
				 obj == SRV_SLD || obj == SRV_DRG);

do
	{
	graf_mkstate(&mouse_x, &mouse_y, &m_button, &k_state);
	}while(m_button & 1);
	
if (last_obj)
	objc_change(server_pop, last_obj, 0, x, y, fw, fh,
							server_pop[last_obj].ob_state & ~SELECTED,
							FALSE);
	
wind_update(END_UPDATE);
form_dial(FMD_FINISH, 0, 0, 0, 0, x - 1, y - 1, fw + 2, fh + 2);
	
if (obj > -1)
	{
	for (i = 0; i < 6; i++)
		if (obj == ftext[i])
			break;
			
	if (i < 6)
		{
		strcpy(ctree[ctobj].ob_spec.tedinfo->te_ptext, snames[i]);
		redraw_object(ctree, ctobj);
		}
	}
}

/* -----------------------
   | Ask for connection  |
   ----------------------- */
int connect_to(void)
{
OBJECT *ctree;
int obj;

rsrc_gaddr(R_TREE, CONNECT, &ctree);
open_dialog(ctree);
do
	{
	obj = do_dialog(ctree, SERVER);
	if (obj == SRVDROP)
		{
		drop_connect(ctree, SERVER);
		}
	}while(obj == SRVDROP);
close_dialog();

return obj == DO_CONN;
}

/* -----------------------------------
   | Add a server to the server list |
   ----------------------------------- */
void add_server(char *server)
{
int i;

for (i = 0; i < server_cnt; i++)
	if (!strcmp(server_list[i], server))
		{
		while(i > 0)
			{
			strcpy(server_list[i], server_list[i - 1]);
			i--;
			}
		strcpy(server_list[0], server);
		return;
		}

if (server_cnt < 30)
	server_cnt++;
	
i = server_cnt - 1;
while(i > 0)
	{
	strcpy(server_list[i], server_list[i - 1]);
	i--;
	}
strcpy(server_list[0], server);
}

/* --------------------------------
   | Load previously used servers |
   -------------------------------- */
void load_servers(void)
{
long fh;
char xid[5];
int i;

fh = Fopen("TRECENT.DAT", FO_READ);
if (fh > 0)
	{
	Fread((int)fh, 4, xid); xid[4] = 0;
	if (strcmp(xid, "TSRV"))
		{
		Fclose((int)fh);
		return;
		}
		
	Fread((int)fh, sizeof(server_cnt), &server_cnt);
	for (i = 0; i < server_cnt; i++)
		Fread((int)fh, sizeof(server_list[0]), server_list[i]);
			
	Fclose((int)fh);
	}
}

/* --------------------------------
   | Save previously used servers |
   -------------------------------- */
void save_servers(void)
{
long fh;
int i;

fh = Fcreate("TRECENT.DAT", 0);
if (fh > 0)
	{
	Fwrite((int)fh, 4, "TSRV");

	Fwrite((int)fh, sizeof(server_cnt), &server_cnt);
	for (i = 0; i < server_cnt; i++)
		Fwrite((int)fh, sizeof(server_list[0]), server_list[i]);
	
	Fclose((int)fh);
	}
}
