/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-08-01
 * 
 */
 
#include "extern.h"

/* --------------------
   | Keyboard control |
   -------------------- */
void Keyboard(void)
{
key_scan = (k_return >> 8) & 0xFF;

if (key_mode == ASCII_MODE)
  key_press = k_return & 0xFF;
else
  key_press = key_scan;

if (key_scan == 0x10 && ((k_state & KCONTROLSHIFT) == KCONTROLLSHIFT || 
												 (k_state & KCONTROLSHIFT) == KCONTROLRSHIFT))
	{
	if (form_alert(1, exit_alert) == 1)
	  exit_flg = TRUE;
	}
else
	if (key_mode == ASCII_MODE)
	  if (!key_press)
	    emulate_key();
	  else
	  	{
	  	if (local_echo) character_out((unsigned char)key_press);
	 	  tcpip_write((unsigned char)key_press);
	 	  }
	else
	 	tcpip_write((char)key_press);
}
