/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-08-01
 * 
 */
 
#include "extern.h"
#include "global.h"

/* ---------------------------- */
/* | Arbeitsstation schlieen | */
/* ---------------------------- */
void cls_vwork(void)
{
v_clsvwk(vdi_handle);
}

/* ---------------------------- */
/* | Virtuelle Arbeitsstation | */
/* ---------------------------- */
void open_vwork(void)
{
register int i;
int dummy;

vdi_handle = graf_handle(&dummy, &dummy, &dummy, &dummy);

for(i = 0; i < 10; work_in[i++] = 1);
work_in[10] = 2;

v_opnvwk(work_in, &vdi_handle, work_out);
}

/* -------------------------
   | Main routine of STTCP |
   ------------------------- */
void main(int argc, char *argv[])
{
gl_apid = appl_init();
open_vwork();

if (!init_rsc())
	{
	if (!_app)
		for (;;)
			evnt_mesag(msg);
	}
else
	{
	rsrc_gaddr(R_TREE, MAINMENU, &menu_adr);

	load_config();
	load_servers();

	if (!_app || CheckSystem())
		menu_register(gl_apid, "  Draconis Telnet");
	if (_app)
		menu_bar(menu_adr, TRUE);
	graf_mouse(ARROW, 0L);

#ifdef WAIT_ABOUT
	about_info(WAIT_FLG);
	DisableObj(menu_adr, M_SELALL);
	DisableObj(menu_adr, M_SAVE);
#endif

	while (!exit_flg)
		{
		which = evnt_multi(MU_MESAG|MU_TIMER|MU_KEYBD|MU_BUTTON,
											 2, 3, 1,
											 0, 0, 0, 0, 0,
											 0, 0, 0, 0, 0,
											 msg,
											 50, 0,
											 &mouse_x, &mouse_y, &m_button,
											 &k_state, &k_return, &clicks);

		if (which & MU_BUTTON)
			mark_window();
			
		if (which & MU_MESAG)		
			message_handler();

		if ((which & MU_TIMER) && crt_window != -1)
			{
			cursor_blink();
			if (marktop_x == -1)
				InController();
			}
			
		if (which & MU_KEYBD)
			Keyboard();
		}
		
	close_connection();

	save_servers();

	exit_objs();
	menu_bar(menu_adr, FALSE);
	}	

cls_vwork();
appl_exit();
}

/* ------------------------
   | handle message queue |
   ------------------------ */
void message_handler(void)
{
switch(msg[0])
	{
	case 0x5810:
		reconnect(FALSE);
		break;

	case AP_TERM:
		exit_flg = TRUE;
		break;
				
	case AC_OPEN:
		break;
		
	case MN_SELECTED:
		menu_handler();
		break;

	case WM_REDRAW:
		check_scrap();
		redraw_crt(msg[4], msg[5], msg[6], msg[7]);
		break;
				
	case WM_NEWTOP:	
	case WM_TOPPED:
		check_scrap();
		wind_set(msg[3], WF_TOP);
		break;

	case WM_FULLED:
		{
		int cx, cy, cw, ch;
		int fx, fy, fw, fh;
		
		wind_get(msg[3], WF_CURRXYWH, &cx, &cy, &cw, &ch);
		wind_get(msg[3], WF_FULLXYWH, &fx, &fy, &fw, &fh);
		if (cx == fx && cy == fy && cw == fw && ch == fh)
			wind_get(msg[3], WF_PREVXYWH, &fx, &fy, &fw, &fh);
			
		wind_set(msg[3], WF_CURRXYWH, fx, fy, fw, fh);
		break;					
		}
		
	case WM_SIZED:
	case WM_MOVED:
		wind_set(msg[3], WF_CURRXYWH, msg[4], msg[5], msg[6], msg[7]);
		break;

	case WM_CLOSED:
		if (msg[3] == crt_window)
			close_connection();
		break;
				
	default:
		break;
	}
}

