/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-08-01
 * 
 */
 
#include "extern.h"

static int f_heads[] = {0, 0, 0, HEAD_4};

static int alertid[] = {NODRIVER, YOFFLINE, SCRAPERR
												};

static char **alerts[]={&nodriver_msg, &offline_msg, &scrap_error
												};

static int opttabs[] = {OPT1, OPT2};

/* -----------------------
   | Initialize resource |
   ----------------------- */
int init_rsc(void)
{
int i;
OBJECT *x, *tree, *tab_x;
int fx, fy, fw, fh;

if (!rsrc_load("DRTELNET.RSC"))
	{
	form_alert(1,"[3][Resource-file|'DRTELNET.RSC' missing.][Oops!]");
	return FALSE;
	}
	
if (work_out[13] < 16)
	for (i = 0; i < 4; i++)
		if (f_heads[i])
			{
			rsrc_gaddr(R_TREE, i, &x);
			x[f_heads[i]].ob_spec.obspec.interiorcol = 0;
			}

rsrc_gaddr(R_STRING, EXIT_MSG, &exit_alert);
rsrc_gaddr(R_STRING, CONCLOS, &conn_closed);
rsrc_gaddr(R_STRING, UNKHOST, &unknown_host);
rsrc_gaddr(R_STRING, UNKSERV, &unknown_service);

/* Set hostname entry */
rsrc_gaddr(R_TREE, CONNECT, &x);
x[SERVER].ob_spec.tedinfo->te_ptext = hostname;

/* Alerts */
for (i = 0; i < sizeof(alertid) / sizeof(int); i++)
	rsrc_gaddr(R_STRING, alertid[i],  alerts[i]);

/* Combine multipage dialogs */
option_tree = NULL;
rsrc_gaddr(R_TREE, TOPTIONS, &tree);
for (i = 0; i < 2; i++)
	{
	rsrc_gaddr(R_TREE, opttabs[i],	&tab_x);
	if (!i)
		opt_pages[i] = CombineDialogs(&option_tree, tree, tab_x);
	else
		opt_pages[i] = CombineDialogs(&option_tree, option_tree, tab_x);
	}

rsrc_gaddr(R_TREE, ICONIFD, &iconified);
form_center(iconified, &fx, &fy, &fw, &fh);
	
init_objs();

return TRUE;
}

