/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-08-01
 * 
 */
 
#include "extern.h"

#define MASK_MODE 1
#define SET_MODE	2
#define OR_MODE   3

USERBLK frameb_ublk 	= {frameb_obj, 0L};
USERBLK check_ublk 		= {check_obj, 0L};
USERBLK radio_ublk 		= {radio_obj, 0L};
USERBLK grey_ublk 		= {grey_obj, 0L};
USERBLK greyb_ublk 		= {greyb_obj, 0L};
USERBLK string_ublk 	= {string_obj, 0L};
USERBLK button_ublk 	= {button_obj, 0L};
USERBLK editfld_ublk 	= {editfld_obj, 0L};
USERBLK text_ublk 		= {text_obj, 0L};
USERBLK password_ublk = {password_obj, 0L};
USERBLK sliderbkg_ublk= {sliderbkg_obj, 0L};
USERBLK slider_ublk		= {slider_obj, 0L};
USERBLK tab_ublk			= {tab_obj, 0L};
USERBLK	label_ublk		= {label_obj, 0L};

BITBLK *check_off, *check_on, *check_msk, *check_gry;
BITBLK *radio_off, *radio_on, *radio_msk, *radio_gry;
BITBLK *radio_gryoff, *radio_gryon;
int obj_vdi, obj_colours, fnt_width, fnt_height;

/* ----------------------
   | Initialize objects |
   ---------------------- */
void init_objs(void)
{
OBJECT *images;
register int i;
int dummy, work_out[57], t_attr[10];

obj_vdi = graf_handle(&dummy, &dummy, &dummy, &dummy);

for(i = 0; i < 10; work_in[i++] = 1);
work_in[10] = 2;

v_opnvwk(work_in, &obj_vdi, work_out);
vqt_attributes(obj_vdi, t_attr);
obj_colours = work_out[13];
vst_alignment(obj_vdi, 0, 5, &dummy, &dummy);
fnt_width = t_attr[8];
fnt_height = t_attr[9];

/* Images */
rsrc_gaddr(R_TREE, IMAGES, &images);

if (t_attr[9] < 16)
	{
	check_off = images[CHECKOF2].ob_spec.bitblk;
	check_on  = images[CHECKON2].ob_spec.bitblk;
	check_msk = images[CHECKMS2].ob_spec.bitblk;
	check_gry = images[CHECKGR2].ob_spec.bitblk;
	
	radio_off = images[RADIOOF2].ob_spec.bitblk;
	radio_on  = images[RADIOON2].ob_spec.bitblk;
	radio_msk = images[RADIOMS2].ob_spec.bitblk;
	radio_gry = images[RADIOGR2].ob_spec.bitblk;

	radio_gryoff = images[RGRYOFF2].ob_spec.bitblk;
	radio_gryon  = images[RGRYON2].ob_spec.bitblk;
	}
else
	{
	check_off = images[CHECKOFF].ob_spec.bitblk;
	check_on  = images[CHECKON].ob_spec.bitblk;
	check_msk = images[CHECKMSK].ob_spec.bitblk;
	check_gry = images[CHECKGRY].ob_spec.bitblk;
	
	radio_off = images[RADIOOFF].ob_spec.bitblk;
	radio_on  = images[RADIOON].ob_spec.bitblk;
	radio_msk = images[RADIOMSK].ob_spec.bitblk;
	radio_gry = images[RADIOGRY].ob_spec.bitblk;

	radio_gryoff = images[RGRYOFF].ob_spec.bitblk;
	radio_gryon  = images[RGRYON].ob_spec.bitblk;
	}
}

/* ----------------------------
   | Exit objects workstation |
   ---------------------------- */
void exit_objs(void)
{
v_clsvwk(obj_vdi);
}

/* ---------------------------------
   | Set special object attributes |
   --------------------------------- */
void set_special_objects(OBJECT *tree)
{
int obj = 0;
USERBLK *new_ublk;

while (obj >= 0)
	{
	if (tree[obj].ob_type & 0xFF00)
		{
		switch(tree[obj].ob_type >> 8)
			{
			case 1:
				new_ublk = &grey_ublk;
				break;
				
			case 2:
				new_ublk = &frameb_ublk;
				break;

			case 3:
				new_ublk = &greyb_ublk;
				break;
				
			case 10:
				new_ublk = &check_ublk;
				break;
				
			case 11:
				new_ublk = &radio_ublk;
				break;
				
			case 12:
				new_ublk = (USERBLK *)malloc(sizeof(USERBLK));
				new_ublk->ub_code = string_ublk.ub_code;
				new_ublk->ub_parm = tree[obj].ob_spec.index;
				break;
			
			case 15:
				new_ublk = (USERBLK *)malloc(sizeof(USERBLK));
				new_ublk->ub_code = button_ublk.ub_code;
				new_ublk->ub_parm = tree[obj].ob_spec.index;
				break;
			
			case 16:
				new_ublk = (USERBLK *)malloc(sizeof(USERBLK));
				new_ublk->ub_code = text_ublk.ub_code;
				new_ublk->ub_parm = tree[obj].ob_spec.index;
				break;
			
			case 17:
				new_ublk = &sliderbkg_ublk;
				break;

			case 18:
				new_ublk = &slider_ublk;
				break;

			case 19:
				new_ublk = (USERBLK *)malloc(sizeof(USERBLK));
				new_ublk->ub_code = tab_ublk.ub_code;
				new_ublk->ub_parm = tree[obj].ob_spec.index;
				break;

			case 40:
				new_ublk = (USERBLK *)malloc(sizeof(USERBLK));
				new_ublk->ub_code = label_ublk.ub_code;
				new_ublk->ub_parm = tree[obj].ob_spec.index;
				break;

			default:
				new_ublk = NULL;
				break;
			}

		if (new_ublk)
			{
			tree[obj].ob_spec.userblk = new_ublk;
			tree[obj].ob_type = (tree[obj].ob_type << 8) | G_USERDEF;
			}
		}
		
	if (tree[obj].ob_flags & LASTOB)
		obj = -1;
	else
		obj++;
	}
}

/* ---------------------------------
   | Set special object attributes |
   --------------------------------- */
void set_edit_specials(OBJECT *tree)
{
int obj = 0;
USERBLK *new_ublk;

while (obj >= 0)
	{
	if ((tree[obj].ob_type & 0xFF00) && (tree[obj].ob_type & 0xFF) != G_USERDEF)
		{
		switch(tree[obj].ob_type >> 8)
			{
			case 13:
				new_ublk = (USERBLK *)malloc(sizeof(USERBLK));
				new_ublk->ub_code = editfld_ublk.ub_code;
				new_ublk->ub_parm = tree[obj].ob_spec.index;
				break;
				
			case 14:
				new_ublk = (USERBLK *)malloc(sizeof(USERBLK));
				new_ublk->ub_code = password_ublk.ub_code;
				new_ublk->ub_parm = tree[obj].ob_spec.index;
				break;
			}

		tree[obj].ob_spec.userblk = new_ublk;
		tree[obj].ob_type = (tree[obj].ob_type << 8) | G_USERDEF;
		}
		
	if (tree[obj].ob_flags & LASTOB)
		obj = -1;
	else
		obj++;
	}
}

/* ---------------------------------
   | Set special object attributes |
   --------------------------------- */
void release_special_objects(OBJECT *tree)
{
int obj = 0, objtype;
USERBLK *old_ublk;

while (obj >= 0)
	{
	if ((tree[obj].ob_type & 0xFF) == G_USERDEF)
		{
		objtype = 0;
		if (tree[obj].ob_spec.userblk->ub_code == string_obj)
			objtype = 12 << 8;

		if (tree[obj].ob_spec.userblk->ub_code == button_obj)
				objtype = 15 << 8;

		if (tree[obj].ob_spec.userblk->ub_code == text_obj)
				objtype = 16 << 8;

		if (tree[obj].ob_spec.userblk->ub_code == tab_obj)
				objtype = 19 << 8;

		if (tree[obj].ob_spec.userblk->ub_code == label_obj)
				objtype = 40 << 8;

		if (objtype)
			{			
			tree[obj].ob_type =  (tree[obj].ob_type >> 8) | objtype;
			old_ublk = tree[obj].ob_spec.userblk;
			tree[obj].ob_spec.index = tree[obj].ob_spec.userblk->ub_parm;
			free(old_ublk);
			}
		}
		
	if (tree[obj].ob_flags & LASTOB)
		obj = -1;
	else
		obj++;
	}
}

/* ---------------------------------
   | Release special edit objectss |
   --------------------------------- */
void release_edit_specials(OBJECT *tree)
{
int obj = 0, objtype;
USERBLK *old_ublk;

while (obj >= 0)
	{
	if ((tree[obj].ob_type & 0xFF) == G_USERDEF)
		{
		objtype = 0;
		if (tree[obj].ob_spec.userblk->ub_code == editfld_obj)
				objtype = 13 << 8;
				
		if (tree[obj].ob_spec.userblk->ub_code == password_obj)
				objtype = 14 << 8;

		if (objtype)
			{
			tree[obj].ob_type =  (tree[obj].ob_type >> 8) | objtype;
			old_ublk = tree[obj].ob_spec.userblk;
			tree[obj].ob_spec.index = tree[obj].ob_spec.userblk->ub_parm;
			free(old_ublk);
			}
		}
		
	if (tree[obj].ob_flags & LASTOB)
		obj = -1;
	else
		obj++;
	}
}

/* ----------------------------
   | Get mnemonic from string |
   ---------------------------- */
void get_string_mnemonic(char *orig, char *dest, int *underline)
{
char *s;

strcpy(dest, orig);
s = dest;
do
	{
	s = strchr(s, '&');
	if (s && s[1] == '&')
		{
		memmove(s, s + 1, strlen(s)); 
		s++;
		}
	else
		break;
		
	}while(1);

if (s)
	{
	*underline = (int)(s - dest);
	memmove(s, s + 1, strlen(s));
	}
else
	*underline = -1;
}

/* ----------------------------
   | Draw character underline |
   ---------------------------- */
void set_underline(int underline, int x, int y)
{
int xy[4];

if (underline > -1)
	{
	xy[0] = x + underline * fnt_width;
	xy[1] = y + fnt_height - 1;
	xy[2] = xy[0] + fnt_width - 1;
	xy[3] = xy[1];
	
	vsl_color(obj_vdi, 1);
	vsl_type(obj_vdi, 1);
	v_pline(obj_vdi, 2, xy);
	}
}

/* ------------------------
   | Radio button painter |
   ------------------------ */
int cdecl radio_obj(PARMBLK *paramblock)
{
obj_clip(paramblock, TRUE);

obj_copy(radio_msk, paramblock->pb_x, paramblock->pb_y, MASK_MODE);
if (paramblock->pb_currstate & SELECTED)
	if (paramblock->pb_currstate & DISABLED)
		obj_copy(radio_gryon, paramblock->pb_x, paramblock->pb_y, OR_MODE);
	else
		obj_copy(radio_on, paramblock->pb_x, paramblock->pb_y, OR_MODE);
else
	if (paramblock->pb_currstate & DISABLED)
		obj_copy(radio_gryoff, paramblock->pb_x, paramblock->pb_y, OR_MODE);
	else
		obj_copy(radio_off, paramblock->pb_x, paramblock->pb_y, OR_MODE);

obj_copy(radio_gry, paramblock->pb_x, paramblock->pb_y, OR_MODE);

obj_clip(paramblock, FALSE);

return 0;
}

/* ------------------------
   | Check button painter |
   ------------------------ */
int cdecl check_obj(PARMBLK *paramblock)
{
obj_clip(paramblock, TRUE);

obj_copy(check_msk, paramblock->pb_x, paramblock->pb_y, MASK_MODE);
if (paramblock->pb_currstate & SELECTED)
	obj_copy(check_on, paramblock->pb_x, paramblock->pb_y, OR_MODE);
else
	obj_copy(check_off, paramblock->pb_x, paramblock->pb_y, OR_MODE);

if (paramblock->pb_currstate & DISABLED)
	{
	int xy[4];
	
	xy[0] = paramblock->pb_x + 2;
	xy[1] = paramblock->pb_y + 2;
	xy[2] = paramblock->pb_x + paramblock->pb_w - 4;
	xy[3] = paramblock->pb_y + paramblock->pb_h - 4;
	vsf_interior(obj_vdi, FIS_PATTERN);
	vsf_style(obj_vdi, 4);
	vsf_color(obj_vdi, 1);
	vswr_mode(obj_vdi, (paramblock->pb_currstate & SELECTED) ? MD_ERASE : MD_TRANS);
	vr_recfl(obj_vdi, xy);
	vswr_mode(obj_vdi, MD_REPLACE);
	}

obj_copy(check_gry, paramblock->pb_x, paramblock->pb_y, OR_MODE);

obj_clip(paramblock, FALSE);

return 0;
}

/* -----------------------
   | frame border object |
   ----------------------- */
int cdecl grey_obj(PARMBLK *paramblock)
{
int xy[4];

obj_clip(paramblock, TRUE);

xy[0] = paramblock->pb_x;
xy[1] = paramblock->pb_y;
xy[2] = xy[0] + paramblock->pb_w - 1;
xy[3] = xy[1] + paramblock->pb_h - 1;

vsf_interior(obj_vdi, FIS_SOLID);
vsf_color(obj_vdi, obj_colours < 16 ? 0 : 8);
vr_recfl(obj_vdi, xy);

obj_clip(paramblock, FALSE);

return 0;
}

/* -----------------------
   | frame border object |
   ----------------------- */
int cdecl greyb_obj(PARMBLK *paramblock)
{
int xy[4];

obj_clip(paramblock, TRUE);

xy[0] = paramblock->pb_x;
xy[1] = paramblock->pb_y;
xy[2] = xy[0] + paramblock->pb_w - 1;
xy[3] = xy[1] + paramblock->pb_h - 1;

vsf_interior(obj_vdi, FIS_SOLID);
vsf_color(obj_vdi, obj_colours < 16 ? 0 : 8);
vr_recfl(obj_vdi, xy);

vsl_color(obj_vdi, 1);
vsl_type(obj_vdi, 1);
xy[3] = xy[1];
v_pline(obj_vdi, 2, xy);
xy[3] = xy[1] = paramblock->pb_y + paramblock->pb_h - 1;
v_pline(obj_vdi, 2, xy);
xy[2] = paramblock->pb_x;
xy[1] = paramblock->pb_y;
v_pline(obj_vdi, 2, xy);
xy[0] = xy[2] = paramblock->pb_x + paramblock->pb_w - 1;
v_pline(obj_vdi, 2, xy);

obj_clip(paramblock, FALSE);

return 0;
}

/* -----------------------
   | frame border object |
   ----------------------- */
int cdecl frameb_obj(PARMBLK *paramblock)
{
int xy[6];

obj_clip(paramblock, TRUE);

xy[0] = paramblock->pb_x;
xy[1] = paramblock->pb_y;
xy[2] = xy[0] + paramblock->pb_w - 1;
xy[3] = xy[1] + paramblock->pb_h - 1;

vsf_interior(obj_vdi, FIS_SOLID);
vsf_color(obj_vdi, obj_colours < 16 ? 0 : 8);
vr_recfl(obj_vdi, xy);

vsl_color(obj_vdi, 1);
vsl_type(obj_vdi, 1);
xy[0] = paramblock->pb_x;
xy[1] = paramblock->pb_y + paramblock->pb_h - 2;
xy[2] = paramblock->pb_x;
xy[3] = paramblock->pb_y;
xy[4] = paramblock->pb_x + paramblock->pb_w - 2;
xy[5] = paramblock->pb_y;
v_pline(obj_vdi, 3, xy);

if (obj_colours >= 16)
	vsl_color(obj_vdi, 0);
xy[0]++; xy[1]--;
xy[2]++; xy[3]++;
xy[4]--; xy[5]++;
v_pline(obj_vdi, 3, xy);

vsl_color(obj_vdi, 1);
vsl_type(obj_vdi, 1);
xy[0] = paramblock->pb_x + paramblock->pb_w - 2;
xy[1] = paramblock->pb_y;
xy[2] = paramblock->pb_x + paramblock->pb_w - 2;
xy[3] = paramblock->pb_y + paramblock->pb_h - 2;
xy[4] = paramblock->pb_x;
xy[5] = paramblock->pb_y + paramblock->pb_h - 2;
v_pline(obj_vdi, 3, xy);

if (obj_colours >= 16)
	vsl_color(obj_vdi, 0);
xy[0]++; xy[1]++;
xy[2]++; xy[3]++;
xy[4]++; xy[5]++;
v_pline(obj_vdi, 3, xy);

obj_clip(paramblock, FALSE);

return 0;
}

/* -----------------------
   | frame border object |
   ----------------------- */
int cdecl string_obj(PARMBLK *paramblock)
{
obj_clip(paramblock, TRUE);

vswr_mode(obj_vdi, MD_TRANS);
if (obj_colours >= 16)
	if (paramblock->pb_currstate & DISABLED)
		{
		vst_color(obj_vdi, 0);
		v_gtext(obj_vdi, paramblock->pb_x + 1, paramblock->pb_y + 1, 
					 (char *)paramblock->pb_parm);
		vst_color(obj_vdi, 9);
		}
	else
		{
		vst_color(obj_vdi, 8);
		v_gtext(obj_vdi, paramblock->pb_x + 1, paramblock->pb_y + 1, 
					 (char *)paramblock->pb_parm);
		vst_color(obj_vdi, 1);
		}
	
vswr_mode(obj_vdi, MD_TRANS);
v_gtext(obj_vdi, paramblock->pb_x, paramblock->pb_y, 
			 (char *)paramblock->pb_parm);
vswr_mode(obj_vdi, MD_REPLACE);

vst_color(obj_vdi, 1);
obj_clip(paramblock, FALSE);

return (obj_colours > 4) ? 0 : (paramblock->pb_currstate & DISABLED);
}

/* -----------------------
   | frame border object |
   ----------------------- */
int cdecl button_obj(PARMBLK *paramblock)
{
int thickness;
int xy[10], w, underline;
char buf[50];

get_string_mnemonic((char *)paramblock->pb_parm, buf, &underline);

grey_obj(paramblock);

obj_clip(paramblock, TRUE);

w = (paramblock->pb_w - (int)strlen((char *)buf) * fnt_width) >> 1;

if (paramblock->pb_currstate & SELECTED)
	w++;
			 
vswr_mode(obj_vdi, MD_TRANS);
if (obj_colours >= 16)
	if (paramblock->pb_currstate & DISABLED)
		{
		vst_color(obj_vdi, 0);
		v_gtext(obj_vdi, paramblock->pb_x + 1 + w, paramblock->pb_y + 1, 
					 	buf);
		vst_color(obj_vdi, 9);
		}
	else
		{
		vst_color(obj_vdi, 8);
		v_gtext(obj_vdi, paramblock->pb_x + 1 + w, paramblock->pb_y + 1, 
					 	buf);
		vst_color(obj_vdi, 1);
		}
	
vswr_mode(obj_vdi, MD_TRANS);
v_gtext(obj_vdi, paramblock->pb_x + w, paramblock->pb_y, 
			 buf);
vswr_mode(obj_vdi, MD_REPLACE);

if (!(paramblock->pb_currstate & DISABLED))
	set_underline(underline, paramblock->pb_x + w, paramblock->pb_y);

vst_color(obj_vdi, 1);

xy[0] = paramblock->pb_x - 1;
xy[1] = paramblock->pb_y + paramblock->pb_h;
xy[3] = paramblock->pb_y - 1;
xy[4] = paramblock->pb_x + paramblock->pb_w;

if  (paramblock->pb_tree[paramblock->pb_obj].ob_flags & 0x4000)
	{
	xy[0]++; xy[3]++;
	xy[1]--; xy[4]--;
	}

xy[2] = xy[0];
xy[5] = xy[3];
xy[6] = xy[4];
xy[7] = xy[1];
xy[8] = xy[0];
xy[9] = xy[1];

if (obj_colours < 16)
	{
	vsl_color(obj_vdi, 1);
	v_pline(obj_vdi, 5, xy);
	}
else
	{
	vsl_color(obj_vdi, (paramblock->pb_currstate & SELECTED) ? 9 : 0);
	v_pline(obj_vdi, 3, xy);
	vsl_color(obj_vdi, (paramblock->pb_currstate & SELECTED) ? 0 : 9);
	v_pline(obj_vdi, 3, xy + 4);
	}

if (paramblock->pb_tree[paramblock->pb_obj].ob_flags & DEFAULT)
	thickness = 1;
else
	thickness = 0;
do
	{
	xy[0]--; xy[1]++;
	xy[2]--; xy[3]--;
	xy[4]++; xy[5]--;
	xy[6]++; xy[7]++;
	xy[8]--; xy[9]++;
	vsl_color(obj_vdi, 1);
	v_pline(obj_vdi, 5, xy);
	}while(thickness--);

if (obj_colours < 16 && (paramblock->pb_currstate & SELECTED))
	{
	xy[0] = paramblock->pb_x;
	xy[1] = paramblock->pb_y;
	xy[2] = xy[0] + paramblock->pb_w - 1;
	xy[3] = xy[1] + paramblock->pb_h - 1;
	
	vswr_mode(obj_vdi, MD_XOR);
	vsf_interior(obj_vdi, FIS_SOLID);
	vsf_color(obj_vdi, 1);
	vr_recfl(obj_vdi, xy);
	vswr_mode(obj_vdi, MD_REPLACE);
	}
	
obj_clip(paramblock, FALSE);

return (obj_colours > 4) ? 0 : (paramblock->pb_currstate & DISABLED);
}

/* ---------------------
   | Edit field object |
   --------------------- */
int cdecl editfld_obj(PARMBLK *paramblock)
{
TEDINFO *tinfo;
int x, y, idx;
char *str, *str2, *buf;
int underline;
char ptmpltbuf[100];

grey_obj(paramblock);

obj_clip(paramblock, TRUE);

tinfo = (TEDINFO *)paramblock->pb_parm;

get_string_mnemonic(tinfo->te_ptmplt, ptmpltbuf, &underline);

x = paramblock->pb_x;
y = paramblock->pb_y;
str2  = ptmpltbuf;

buf = (char *)malloc(tinfo->te_tmplen + 1);

vswr_mode(obj_vdi, MD_TRANS);

idx = 0;
str = tinfo->te_ptext;
while(*str2)
	{
	if (*str2 == '_' && *str)
		buf[idx++] = *str++;
	else
		buf[idx++] = *str2;
	str2++;
	}
buf[idx] = 0;

x += (tinfo->te_tmplen - (int)strlen(buf) - 1) * fnt_width;
if (obj_colours >= 16)
	if (paramblock->pb_currstate & DISABLED)
		{
		vst_color(obj_vdi, 0);
		v_gtext(obj_vdi, x + 1, y + 1, buf);
		vst_color(obj_vdi, 9);
		}
	else
		{
		vst_color(obj_vdi, 8);
		v_gtext(obj_vdi, x + 1, y + 1, buf);
		vst_color(obj_vdi, 1);
		}
v_gtext(obj_vdi, x, y, buf);

if (!(paramblock->pb_currstate & DISABLED))
	set_underline(underline, x, y);

free(buf);

vswr_mode(obj_vdi, MD_REPLACE);
obj_clip(paramblock, FALSE);

/*				
    int     te_font;           /* Zeichensatz                      */
    int     te_just;           /* Justierung des Texts             */
    int     te_color;          /* Farbe                            */
*/

return (obj_colours > 4) ? 0 : (paramblock->pb_currstate & DISABLED);
}

/* -------------------
   | Password object |
   ------------------- */
int cdecl password_obj(PARMBLK *paramblock)
{
TEDINFO *tinfo;
int x, y, idx;
char *str, *str2, *buf;
int underline;
char ptmpltbuf[100];

grey_obj(paramblock);

obj_clip(paramblock, TRUE);

tinfo = (TEDINFO *)paramblock->pb_parm;

get_string_mnemonic(tinfo->te_ptmplt, ptmpltbuf, &underline);

x = paramblock->pb_x;
y = paramblock->pb_y;
str2  = ptmpltbuf;

buf = (char *)malloc(tinfo->te_tmplen + 1);

vswr_mode(obj_vdi, MD_TRANS);

idx = 0;
str = tinfo->te_ptext;
while(*str2)
	{
	if (*str2 == '_' && *str)
		{
		buf[idx++] = '*';
		str++;
		}
	else
		buf[idx++] = *str2;
	str2++;
	}
buf[idx] = 0;

x += (tinfo->te_tmplen - (int)strlen(buf) - 1) * fnt_width;

if (obj_colours >= 16)
	if (paramblock->pb_currstate & DISABLED)
		{
		vst_color(obj_vdi, 0);
		v_gtext(obj_vdi, x + 1, y + 1, buf);
		vst_color(obj_vdi, 9);
		}
	else
		{
		vst_color(obj_vdi, 8);
		v_gtext(obj_vdi, x + 1, y + 1, buf);
		vst_color(obj_vdi, 1);
		}
v_gtext(obj_vdi, x, y, buf);

if (!(paramblock->pb_currstate & DISABLED))
	set_underline(underline, x, y);

free(buf);

vswr_mode(obj_vdi, MD_REPLACE);
obj_clip(paramblock, FALSE);

return (obj_colours > 4) ? 0 : (paramblock->pb_currstate & DISABLED);
}

/* ---------------------
   | Text field object |
   --------------------- */
int cdecl text_obj(PARMBLK *paramblock)
{
TEDINFO *tinfo;
int x, y, xy[10], thickness;

grey_obj(paramblock);

obj_clip(paramblock, TRUE);

tinfo = (TEDINFO *)paramblock->pb_parm;

x = paramblock->pb_x;
y = paramblock->pb_y;

vswr_mode(obj_vdi, MD_TRANS);

vst_color(obj_vdi, tinfo->te_color);
if (tinfo->te_just)
	{
	int d, ext[8];
	
	vqt_extent(obj_vdi, tinfo->te_ptext, ext);
	d = ext[2] - ext[0];
	if (d < 0) d = -d;
	d = paramblock->pb_w - d;
	
	if (tinfo->te_just == 2) d >>= 1;
	x += d;
	}
	
v_gtext(obj_vdi, x, y, tinfo->te_ptext);
vst_color(obj_vdi, 1);

xy[0] = paramblock->pb_x - 1;
xy[1] = paramblock->pb_y + paramblock->pb_h;
xy[2] = xy[0];
xy[3] = paramblock->pb_y - 1;
xy[4] = paramblock->pb_x + paramblock->pb_w;
xy[5] = xy[3];
xy[6] = xy[4];
xy[7] = xy[1];
xy[8] = xy[0];
xy[9] = xy[1];
thickness = tinfo->te_thickness;
while(thickness)
	{
	if (thickness < 0)
		{
		xy[0]++; xy[1]--;
		xy[2]++; xy[3]++;
		xy[4]--; xy[5]++;
		xy[6]--; xy[7]--;
		xy[8]++; xy[9]--;
		thickness++;
		}
	else
		{
		xy[0]--; xy[1]++;
		xy[2]--; xy[3]--;
		xy[4]++; xy[5]--;
		xy[6]++; xy[7]++;
		xy[8]--; xy[9]++;
		thickness--;
		}
	if (obj_colours < 16)
		{
		vsl_color(obj_vdi, 1);
		v_pline(obj_vdi, 5, xy);
		}
	else
		{
		vsl_color(obj_vdi, 9);
		v_pline(obj_vdi, 3, xy);
		vsl_color(obj_vdi, 0);
		v_pline(obj_vdi, 3, xy + 4);
		}
	}
	
vswr_mode(obj_vdi, MD_REPLACE);
obj_clip(paramblock, FALSE);

/*				
    int     te_font;           /* Zeichensatz                      */
*/

return (obj_colours > 4) ? 0 : (paramblock->pb_currstate & DISABLED);
}

/* -------------------
   | Tab page object |
   ------------------- */
int cdecl tab_obj(PARMBLK *paramblock)
{
int xy[10], w;

obj_clip(paramblock, TRUE);

xy[0] = paramblock->pb_x + 1;
xy[1] = paramblock->pb_y + paramblock->pb_h - 1;
xy[2] = paramblock->pb_x + (paramblock->pb_h >> 1) - 1 + 1;
xy[3] = paramblock->pb_y;
xy[4] = paramblock->pb_x + paramblock->pb_w - 1 - (paramblock->pb_h >> 1) - 1 - 1;
xy[5] = paramblock->pb_y;
xy[6] = paramblock->pb_x + paramblock->pb_w - 1 - 2;
xy[7] = paramblock->pb_y + paramblock->pb_h - 1;
xy[8] = xy[0];
xy[9] = xy[1];

vsf_interior(obj_vdi, FIS_SOLID);
vsf_color(obj_vdi, (obj_colours >= 16) ? 8 : 0);
v_fillarea(obj_vdi, 5, xy);
	
vsl_color(obj_vdi, 1);
v_pline(obj_vdi, 4, xy);

xy[0]--;
xy[3]--;
xy[2]--;
xy[5]--;
vsl_color(obj_vdi, 0);
v_pline(obj_vdi, 3, xy);

xy[5] += 2;
xy[6]--;
if (obj_colours >= 16)
	{
	vsl_color(obj_vdi, 9);
	v_pline(obj_vdi, 2, xy + 4);
	}
	
if (paramblock->pb_currstate & SELECTED)
	{
	xy[6]--; xy[8]++;
	vsl_color(obj_vdi, (obj_colours >= 16) ? 8 : 0);
	v_pline(obj_vdi, 2, xy + 6);
	xy[7]++; xy[9]++;
	v_pline(obj_vdi, 2, xy + 6);
	xy[7]++; xy[9]++;
	v_pline(obj_vdi, 2, xy + 6);
	}
	
w = (paramblock->pb_w - (int)strlen((char *)paramblock->pb_parm) * 
		 fnt_width) >> 1;

vswr_mode(obj_vdi, MD_TRANS);
if (obj_colours >= 16)
	if (paramblock->pb_currstate & DISABLED)
		{
		vst_color(obj_vdi, 0);
		v_gtext(obj_vdi, paramblock->pb_x + 1 + w, paramblock->pb_y + 1, 
					 (char *)paramblock->pb_parm);
		vst_color(obj_vdi, 9);
		}
	else
		{
		vst_color(obj_vdi, 8);
		v_gtext(obj_vdi, paramblock->pb_x + 1 + w, paramblock->pb_y + 1, 
					 (char *)paramblock->pb_parm);
		vst_color(obj_vdi, 1);
		}
	
vswr_mode(obj_vdi, MD_TRANS);
v_gtext(obj_vdi, paramblock->pb_x + w, paramblock->pb_y, 
			 (char *)paramblock->pb_parm);
vswr_mode(obj_vdi, MD_REPLACE);

vst_color(obj_vdi, 1);

obj_clip(paramblock, FALSE);

return (obj_colours > 4) ? 0 : (paramblock->pb_currstate & DISABLED);
}

/* -----------------------
   | frame border object |
   ----------------------- */
int cdecl sliderbkg_obj(PARMBLK *paramblock)
{
int xy[4];

obj_clip(paramblock, TRUE);

xy[0] = paramblock->pb_x;
xy[1] = paramblock->pb_y;
xy[2] = xy[0] + paramblock->pb_w - 1;
xy[3] = xy[1] + paramblock->pb_h - 1;

if (obj_colours < 16)
	{
	vsf_interior(obj_vdi, FIS_PATTERN);
	vsf_style(obj_vdi, 4);
	vsf_color(obj_vdi, 1);
	}
else
	{
	vsf_interior(obj_vdi, FIS_SOLID);
	vsf_color(obj_vdi, 9);
	}
vr_recfl(obj_vdi, xy);

vsl_color(obj_vdi, 1);
xy[0] = xy[2] = paramblock->pb_x - 1;
v_pline(obj_vdi, 2, xy);

xy[0] = xy[2] = paramblock->pb_x + paramblock->pb_w - 1;
vsl_color(obj_vdi, (obj_colours < 16) ? 1 : 9);
v_pline(obj_vdi, 2, xy);

xy[0]++; xy[2]++;
vsl_color(obj_vdi, 1);
v_pline(obj_vdi, 2, xy);

obj_clip(paramblock, FALSE);

return 0;
}

/* -----------------
   | slider object |
   ----------------- */
int cdecl slider_obj(PARMBLK *paramblock)
{
int xy[6];

obj_clip(paramblock, TRUE);

xy[0] = paramblock->pb_x;
xy[1] = paramblock->pb_y;
xy[2] = xy[0] + paramblock->pb_w - 1;
xy[3] = xy[1] + paramblock->pb_h - 1;

vsf_interior(obj_vdi, FIS_SOLID);
vsf_color(obj_vdi, (obj_colours < 16) ? 0 : 8);
vr_recfl(obj_vdi, xy);

xy[0] = paramblock->pb_x;
xy[1] = paramblock->pb_y + paramblock->pb_h - 1;
xy[2] = xy[0];
xy[3] = paramblock->pb_y;
xy[4] = paramblock->pb_x + paramblock->pb_w - 1;
xy[5] = xy[3];
vsl_color(obj_vdi, (obj_colours < 16) ? 1 : 0);
v_pline(obj_vdi, 3, xy);
xy[2] = xy[4];
xy[3] = xy[1];
vsl_color(obj_vdi, 1);
v_pline(obj_vdi, 3, xy);

obj_clip(paramblock, FALSE);

return 0;
}

/* ----------------
   | Label object |
   ---------------- */
int cdecl label_obj(PARMBLK *paramblock)
{
int underline;
char buf[50];

get_string_mnemonic((char *)paramblock->pb_parm, buf, &underline);
	
obj_clip(paramblock, TRUE);

vswr_mode(obj_vdi, MD_TRANS);
if (obj_colours >= 16)
	if (paramblock->pb_currstate & DISABLED)
		{
		vst_color(obj_vdi, 0);
		v_gtext(obj_vdi, paramblock->pb_x + 1, paramblock->pb_y + 1, 
					 buf);
		vst_color(obj_vdi, 9);
		}
	else
		{
		vst_color(obj_vdi, 8);
		v_gtext(obj_vdi, paramblock->pb_x + 1, paramblock->pb_y + 1, 
					 buf);
		vst_color(obj_vdi, 1);
		}
	
vswr_mode(obj_vdi, MD_TRANS);
v_gtext(obj_vdi, paramblock->pb_x, paramblock->pb_y, buf);
vswr_mode(obj_vdi, MD_REPLACE);

if (!(paramblock->pb_currstate & DISABLED))
	set_underline(underline, paramblock->pb_x, paramblock->pb_y);

vst_color(obj_vdi, 1);
obj_clip(paramblock, FALSE);

if (obj_colours >= 16)
	return paramblock->pb_currstate & ~DISABLED;
else
	return paramblock->pb_currstate;
}

/* ---------------------------------
   | Bitblt object image on screen |
   --------------------------------- */
void obj_copy(BITBLK *blk, int xt, int yt, int mode)
{
int pxy[8], colidx[2];
MFDB msrc, mdes;

switch(mode)
	{
	case MASK_MODE:	mode = MD_ERASE; break;
	case SET_MODE:	mode = MD_REPLACE; break;
	case OR_MODE:		mode = MD_TRANS; break;
	}

msrc.fd_addr = blk->bi_pdata;
msrc.fd_w = blk->bi_wb << 3;
msrc.fd_h = blk->bi_hl;
msrc.fd_wdwidth = (msrc.fd_w + 15) >> 4;
msrc.fd_stand = 
msrc.fd_nplanes = 1;

mdes.fd_addr = 0L;

pxy[0] = 0;
pxy[1] = 0;
pxy[2] = msrc.fd_w - 1;
pxy[3] = blk->bi_hl - 1;
pxy[4] = xt + blk->bi_x;
pxy[5] = yt + blk->bi_y;
pxy[6] = pxy[4] + msrc.fd_w - 1;
pxy[7] = pxy[5] + blk->bi_hl - 1;

if (mode != MD_ERASE)
	{
	colidx[0] = blk->bi_color;
	colidx[1] = 0;
	}
else
	{
	colidx[0] = 1;
	colidx[1] = 0;
	}
vrt_cpyfm(obj_vdi, mode, pxy, &msrc, &mdes, colidx);
}

/* --------------------------------
   | Set/Unset clipping rectangle |
   -------------------------------- */
void obj_clip(PARMBLK *parm, int flg)
{
int cxy[4];

cxy[0] = parm->pb_xc;
cxy[1] = parm->pb_yc;
cxy[2] = cxy[0] + parm->pb_wc - 1;
cxy[3] = cxy[1] + parm->pb_hc - 1;

vs_clip(obj_vdi, flg, cxy);
vswr_mode(obj_vdi, MD_REPLACE);
}